git: fb4114332463 - main - Added a new unionfs test scenario. Removed a few old unionfs tests from the exclude list

From: Peter Holm <pho_at_FreeBSD.org>
Date: Mon, 15 Nov 2021 09:42:05 UTC
The branch main has been updated by pho:

URL: https://cgit.FreeBSD.org/src/commit/?id=fb41143324635477f4e21af3f89d626b730fc053

commit fb41143324635477f4e21af3f89d626b730fc053
Author:     Peter Holm <pho@FreeBSD.org>
AuthorDate: 2021-11-15 09:40:51 +0000
Commit:     Peter Holm <pho@FreeBSD.org>
CommitDate: 2021-11-15 09:40:51 +0000

    Added a new unionfs test scenario.  Removed a few old unionfs tests from
    the exclude list
---
 tools/test/stress2/misc/all.exclude |  5 +-
 tools/test/stress2/misc/unionfs6.sh | 97 +++++++++++++++++++++++++++++++++++++
 2 files changed, 98 insertions(+), 4 deletions(-)

diff --git a/tools/test/stress2/misc/all.exclude b/tools/test/stress2/misc/all.exclude
index 220fb119dcc3..c93eb8779260 100644
--- a/tools/test/stress2/misc/all.exclude
+++ b/tools/test/stress2/misc/all.exclude
@@ -73,11 +73,8 @@ syzkaller43.sh		WiP								20210906
 syzkaller46.sh		WiP								20211026
 syzkaller47.sh		WiP								20211026
 truss3.sh		WiP								20200915
-unionfs.sh		insmntque: non-locked vp: xx is not exclusive locked...		20130909
-unionfs2.sh		insmntque: mp-safe fs and non-locked vp is not ...		20111219
-unionfs3.sh		insmntque: mp-safe fs and non-locked vp is not ...		20111216
 unionfs4.sh		WiP								20210916
-unionfs5.sh		WiP								20210916
+unionfs6.sh		WiP								20211115
 zfs14.sh		WiP								20211110
 
 # Test not to run for other reasons:
diff --git a/tools/test/stress2/misc/unionfs6.sh b/tools/test/stress2/misc/unionfs6.sh
new file mode 100755
index 000000000000..21620f3f39b6
--- /dev/null
+++ b/tools/test/stress2/misc/unionfs6.sh
@@ -0,0 +1,97 @@
+#!/bin/sh
+
+#
+# SPDX-License-Identifier: BSD-2-Clause-FreeBSD
+#
+# Copyright (c) 2021 Peter Holm
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+#    notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+#    notice, this list of conditions and the following disclaimer in the
+#    documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+# SUCH DAMAGE.
+#
+
+# unionfs(8) test
+# "panic: ufs dir vp 0xfffffe0157351068 ip 0xfffffe016a63d488 flags 0x3c06" seen
+
+[ `id -u ` -ne 0 ] && echo "Must be root!" && exit 1
+. ../default.cfg
+
+md1=$mdstart
+md2=$((md1 + 1))
+mp1=/mnt$md1
+mp2=/mnt$md2
+mkdir -p $mp1 $mp2
+set -e
+for i in $mp1 $mp2; do
+	mount | grep -q "on $i " && umount -f $i
+done
+for i in $md1 $md2; do
+	mdconfig -l | grep -q md$i && mdconfig -d -u $i
+done
+
+mdconfig -a -t swap -s 4g -u $md1
+mdconfig -a -t swap -s 4g -u $md2
+newfs $newfs_flags -n md$md1 > /dev/null
+newfs $newfs_flags -n md$md2 > /dev/null
+mount /dev/md$md1 $mp1
+mount /dev/md$md2 $mp2
+
+mount -t unionfs -o noatime $mp1 $mp2
+set +e
+mount | grep -E "$mp1|$mp2"
+
+export CTRLDIR=$mp2/stressX.control
+export INCARNATIONS=10
+export LOAD=80
+export RUNDIR=$mp2/stressX
+export runRUNTIME=5m
+export rwLOAD=80
+export symlinkLOAD=80
+
+export TESTPROGS="
+testcases/lockf2/lockf2
+testcases/symlink/symlink
+testcases/openat/openat
+testcases/rw/rw
+testcases/fts/fts
+testcases/link/link
+testcases/lockf/lockf
+testcases/creat/creat
+testcases/mkdir/mkdir
+testcases/rename/rename
+testcases/mkfifo/mkfifo
+testcases/dirnprename/dirnprename
+testcases/dirrename/dirrename
+testcases/swap/swap
+"
+
+set +e
+chmod 777 $mp2
+su $testuser -c \
+	'(cd ..; ./testcases/run/run $TESTPROGS)'
+
+umount $mp2	# The unionfs mount
+umount $mp2
+n=`find $mp1/stressX | wc -l`
+[ $n -eq 1 ] && s=0 || { find $mp1/stressX -ls | head -12; s=1; }
+umount $mp1
+mdconfig -d -u $md2
+mdconfig -d -u $md1
+exit $s